/***************************************************************************
                          dialog_directories.h  -  description
                             -------------------
    begin                : Mon Mar 27 2000
    copyright            : (C) 2000 - 2003 by M. Hoverath
    email                : mario.hoverath@uni-koeln.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _DIRECTORIESDIALOG
#define _DIRECTORIESDIALOG

/* include files for QT */
#include <qvariant.h>
#include <qframe.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qstring.h>
#include <qptrlist.h>
#include <qpixmap.h>

/* application specific includes */
#include "kmovistodoc.h"
#include "dialog_directories_ui.h"
#include "ipluginmanager.h"
#include "resource.h"

/* class CDirectoriesDialog */
class CDirectoriesDialog : public CDirectoriesDialogUI
{
  Q_OBJECT

public:
  /* constructor */
  CDirectoriesDialog(QWidget *parent = 0, const char *name = 0, WFlags f = 0);

  /* destructor */
  ~CDirectoriesDialog();

public:
  /* get... */
  int getApplyStatus(void) {return(!applyButton->isEnabled());}
  QString getDirectory(int filetype);
  QString getFilter(int filetype);
  void getPluginProperties(CIPluginManager* pm);

  /* set... */
  void setDirectory(QString newDirectory, int filetype);
  void setFilter(QString newFilter, int filetype);
  void setPluginProperties(CIPluginManager* pm);

private slots:
  void applyClicked(void);
  void resetClicked(void);
  void settingsChanged(void);
  void pluginHighlighted(int item);
  void directoryChanged(const QString& directory);
  void filterChanged(const QString& filter);

protected:
  /* protected members */
  bool initDialog;
  CIPluginManager* pluginManager;
  QPtrList<int> *pIdList;
  QPtrList<QString> *pPluginDirectoryList;
  QPtrList<QString> *pPluginFilterList;
};

#endif /* _DIRECTORIESDIALOG */
