/***************************************************************************
                          dialog_g94imp.cpp  -  description
                             -------------------
    begin                : Sat Feb 19 2000
    copyright            : (C) 2000 - 2003 by M. Hoverath
    email                : mario.hoverath@uni-koeln.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <dialog_g94imp.h>

/////////////////////////////////////////////////////////////////////////////
// definition of the class CImpG94Dialog
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Constructor
CImpG94Dialog::CImpG94Dialog(QWidget *parent, const char *name, WFlags f)
  : CImpG94DialogUI(parent, name, TRUE, f)
{
  // initialisations
  Path = "";
  NumberOfCalculations = 0;
  Parameters = "";
  Title = "";
  Selection = 0;

  // connections
  connect(acceptButton, SIGNAL(clicked()), SLOT(accept()));
  connect(cancelButton, SIGNAL(clicked()), SLOT(reject()));
  connect(selectionSpinBox, SIGNAL(valueChanged(int)), this, SLOT(updateSelection(int)));
}

/////////////////////////////////////////////////////////////////////////////
// Destructor
CImpG94Dialog::~CImpG94Dialog()
{
}

/////////////////////////////////////////////////////////////////////////////
// SLOT updateSelection
void CImpG94Dialog::updateSelection(int value)
{
  selectionLineEdit1->setText(g94file.GetTypeOfCalculation(value));
  selectionLineEdit2->setText(g94file.GetTitle(value));
}

/////////////////////////////////////////////////////////////////////////////
// SetG94File
void CImpG94Dialog::SetG94File(CG94File &G94File)
{
  if(G94File.GetNumberOfCalculations() > 0)
  {
    selectionSpinBox->setRange(1, G94File.GetNumberOfCalculations());
    selectionSpinBox->setValue(1);
    fileLineEdit1->setText(G94File.GetPathName());
    fileLabel3->setNum(G94File.GetNumberOfCalculations());
    selectionLineEdit1->setText(G94File.GetTypeOfCalculation(1));
    selectionLineEdit2->setText(G94File.GetTitle(1));
  }
  else
  {
    selectionSpinBox->setRange(0, 0);
    selectionSpinBox->setValue(0);
    fileLineEdit1->setText("");
    fileLabel3->setNum(0);
    selectionLineEdit1->setText("");
    selectionLineEdit2->setText("");
  }
  g94file = G94File;
}

/////////////////////////////////////////////////////////////////////////////
// GetSelection
int CImpG94Dialog::GetSelection(void)
{
  return selectionSpinBox->value();
}
