/***************************************************************************
                          dialog_plugin.h  -  description
                             -------------------
    begin                : Sun Aug 17 2003
    copyright            : (C) 2000 - 2003 by M. Hoverath
    email                : mario.hoverath@uni-koeln.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _PLUGINDIALOG
#define _PLUGINDIALOG

/* include files for QT */
#include <qvariant.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qtextedit.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qpixmap.h>
#include <qptrlist.h>
#include <qmessagebox.h>
#include <qfiledialog.h>

/* application specific includes */
#include "dialog_plugin_ui.h"
#include "ipluginmanager.h"
#include "resource.h"
#include "initfile.h"
#include <typeinfo>

/* class CPluginDialog */
class CPluginDialog : public CPluginDialogUI
{
  Q_OBJECT

public:
  /* constructor */
  CPluginDialog(QWidget *parent = 0, const char *name = 0, WFlags f = 0);

  /* destructor */
  ~CPluginDialog();

public:
  /* set ... */
  void setPluginManager(CIPluginManager* pm);
  void setPluginDirectory(QString& directory) {directory;};
  void setPluginFilter(QString& filter);
  
  /* get ... */
  void getPluginManager(CIPluginManager* pm);

  /* misc */
  bool isModified(void) {return(modified);};
  
protected:
  bool rewriteInitFile(void);
  bool insertPlugins(void);
  
private slots:
  void slotPluginHighlighted(int item);
  void slotAddClicked(void);
  void slotDeleteClicked(void);
   
protected:
  /* protected members */
  CIPluginManager* pluginManager;
  bool modified;
  QString pluginDirectory;
  QString pluginFilter;
  CInitFile initfile;
  QPtrList<int> *pIdList;
};

#endif /* _PLUGINDIALOG */
