/***************************************************************************
                          dialog_title.cpp  -  description
                             -------------------
    begin                : Mon Mar 27 2000
    copyright            : (C) 2000 - 2003 by M. Hoverath
    email                : mario.hoverath@uni-koeln.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <dialog_title.h>


/////////////////////////////////////////////////////////////////////////////
// definition of the class CTitleDialog
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Constructor
CTitleDialog::CTitleDialog(QWidget *parent, const char *name, WFlags f)
  : CTitleDialogUI(parent, name, TRUE, f)
{
  molecule = new CKGLMolecule(this, "dlgmolecule");
  molecule->DeleteMolecule();

  // connections
  // button clicked
  connect(acceptButton, SIGNAL(clicked()), SLOT(accept()));
  connect(cancelButton, SIGNAL(clicked()), SLOT(reject()));
  // title changed
  connect(titleLineEdit, SIGNAL(textChanged(const QString&)), SLOT(titleLineEditChanged(const QString&)));
}

/////////////////////////////////////////////////////////////////////////////
// Destructor
CTitleDialog::~CTitleDialog()
{
}

/////////////////////////////////////////////////////////////////////////////
// slots
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// slot titleLineEditChanged
void CTitleDialog::titleLineEditChanged(const QString& newTitle)
{
  molecule->SetTitle(newTitle);
}

/////////////////////////////////////////////////////////////////////////////
// slot initWidgets
void CTitleDialog::initWidgets(void)
{
  titleLineEdit->setText(molecule->GetTitle());
}

/////////////////////////////////////////////////////////////////////////////
// methods
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// setMolecule
void CTitleDialog::setMolecule(CKGLMolecule *mol)
{
  *molecule = *mol;
  initWidgets();
}

/////////////////////////////////////////////////////////////////////////////
// getMolecule
CKGLMolecule* CTitleDialog::getMolecule(void)
{
  return(molecule);
}

