/***************************************************************************
                          introscreen.cpp  -  description
                             -------------------
    begin                : Sun Dec 29 2002
    copyright            : (C) 2000 - 2003 by M. Hoverath
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "introscreen.h"

CIntroScreen::CIntroScreen(const char *xpm[], QWidget *parent, const char *name)
 : QWidget(parent, name, Qt::WType_TopLevel|Qt::WStyle_StaysOnTop|Qt::WStyle_Customize|Qt::WStyle_NoBorder)
{
  introtime = 0;

  timer = new QTimer(this, "timer");
  connect(timer, SIGNAL(timeout()), this, SLOT(timerDone()));

  intropixmap = QPixmap(xpm);
  width = intropixmap.width();
  height = intropixmap.height();

  QWidget *d = QApplication::desktop();
  setGeometry(d->width() / 2 - width / 2, d->height() / 2 - height / 2, width, height);

  setBackgroundPixmap(intropixmap);
}

CIntroScreen::~CIntroScreen()
{

}

void CIntroScreen::show(int msec)
{
  introtime = msec;
  QWidget::show();
}

void CIntroScreen::showEvent(QShowEvent*)
{
  timer->start(introtime, TRUE);
}

void CIntroScreen::timerDone()
{
  hide();
}
