/***************************************************************************
                          ipluginmanager.h  -  description
                             -------------------
    begin                : Mon Aug 4 2003
    copyright            : (C) 2003 by M. Hoverath
    email                : mario.hoverath@uni-koeln.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _IPLUGIN_H
#define _IPLUGIN_H

/* include files for QT */
#include <qobject.h>
#include <qptrlist.h>

/* application specific includes */
#include "iplugin.h"
#include <dlfcn.h>

/* class CIPluginContainer */
class CIPluginContainer
{
public:
  CIPluginContainer(kmpi::CIPlugin* plugin, QString& file, void* handle, int id, QString& directory, QString& filter);
  ~CIPluginContainer(void);
  kmpi::CIPlugin* getPlugin(void) {return(pluginObject);};
  int getId(void) {return(idNumber);};
  QString getLibrary(void) {return(library);};
  QString getWorkingDirectory(void) {return(workingDirectory);};
  QString getWorkingFilter(void) {return(workingFilter);};
  void setWorkingDirectory(QString& directory) {workingDirectory = directory;};
  void setWorkingFilter(QString& filter) {workingFilter = filter;};

protected:
  void* pluginHandle;
  kmpi::CIPlugin* pluginObject;
  int idNumber;
  QString library;
  QString workingDirectory;
  QString workingFilter;
};

/* class CIPluginManager */
class CIPluginManager : QObject
{
  Q_OBJECT

public:
  CIPluginManager(QObject *parent = 0, const char *name = 0);
  ~CIPluginManager();
  unsigned int getNumberOfPlugins(void);
  unsigned int getNumberOfPlugins(kmpi::KMPI_INTERFACE_TYPE type);
  bool addLibrary(QString& library, int id, QString& directory, QString& filter);
  bool addLibrary(CIPluginContainer* pluginContainer);
  bool deleteLibrary(int id);
  bool clear();
  bool clear(kmpi::KMPI_INTERFACE_TYPE type);
  QPtrList<CIPluginContainer>* getPluginList(kmpi::KMPI_INTERFACE_TYPE type);
  CIPluginContainer* getPluginContainer(int id);
  CIPluginContainer* getPluginContainer(kmpi::KMPI_INTERFACE_TYPE type, int id);
  kmpi::CIPlugin* getPlugin(int id);
  
protected:
  QPtrList<CIPluginContainer> *pFileImportPluginList;
  QPtrList<CIPluginContainer> *pFileExportPluginList;
  QPtrList<CIPluginContainer> *pFileImportDialogPluginList;
  QPtrList<CIPluginContainer> *pFileExportDialogPluginList;
};

#endif
