/***************************************************************************
                          kglmolecule.cpp  -  description
                             -------------------
    begin                : Sat Sep 7 2002
    copyright            : (C) 2000 - 2003 by M. Hoverath
    email                : mario.hoverath@uni-koeln.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kglmolecule.h"

/////////////////////////////////////////////////////////////////////////////
// definition of the class CKPeriodicSystem
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// constructor

CKPeriodicSystem::CKPeriodicSystem(QObject *parent, const char *name)
  : CPeriodicSystem(parent, name)
{
  int i = 0;
  QString str_i = "";
  QString str_Radius = "";
  QString str_Color = "";
  QString str_Pattern = "";

  for(i = 1; i < 110; i++)
  {
    str_i.setNum(i);

    // read radii from INITFILE
    str_Radius = initfile.GetProfile("Radius", str_i, "");
    if(str_Radius == "")
    {
      switch(i)
      {
        case 1:  str_Radius = "0.320"; break;
        case 2:  str_Radius = "0.930"; break;
        case 3:  str_Radius = "1.230"; break;
        case 4:  str_Radius = "0.900"; break;
        case 5:  str_Radius = "0.820"; break;
        case 6:  str_Radius = "0.770"; break;
        case 7:  str_Radius = "0.750"; break;
        case 8:  str_Radius = "0.730"; break;
        case 9:  str_Radius = "0.720"; break;
        case 10:  str_Radius = "0.710"; break;
        case 11:  str_Radius = "1.540"; break;
        case 12:  str_Radius = "1.360"; break;
        case 13:  str_Radius = "1.180"; break;
        case 14:  str_Radius = "1.110"; break;
        case 15:  str_Radius = "1.060"; break;
        case 16:  str_Radius = "1.020"; break;
        case 17:  str_Radius = "0.990"; break;
        case 18:  str_Radius = "0.980"; break;
        case 19:  str_Radius = "2.030"; break;
        case 20:  str_Radius = "1.740"; break;
        case 21:  str_Radius = "1.440"; break;
        case 22:  str_Radius = "1.320"; break;
        case 23:  str_Radius = "1.220"; break;
        case 24:  str_Radius = "1.180"; break;
        case 25:  str_Radius = "1.170"; break;
        case 26:  str_Radius = "1.170"; break;
        case 27:  str_Radius = "1.160"; break;
        case 28:  str_Radius = "1.150"; break;
        case 29:  str_Radius = "1.170"; break;
        case 30:  str_Radius = "1.250"; break;
        case 31:  str_Radius = "1.260"; break;
        case 32:  str_Radius = "1.220"; break;
        case 33:  str_Radius = "1.200"; break;
        case 34:  str_Radius = "1.160"; break;
        case 35:  str_Radius = "1.140"; break;
        case 36:  str_Radius = "1.120"; break;
        case 37:  str_Radius = "2.160"; break;
        case 38:  str_Radius = "1.910"; break;
        case 39:  str_Radius = "1.620"; break;
        case 40:  str_Radius = "1.450"; break;
        case 41:  str_Radius = "1.340"; break;
        case 42:  str_Radius = "1.300"; break;
        case 43:  str_Radius = "1.270"; break;
        case 44:  str_Radius = "1.250"; break;
        case 45:  str_Radius = "1.250"; break;
        case 46:  str_Radius = "1.280"; break;
        case 47:  str_Radius = "1.340"; break;
        case 48:  str_Radius = "1.480"; break;
        case 49:  str_Radius = "1.440"; break;
        case 50:  str_Radius = "1.410"; break;
        case 51:  str_Radius = "1.400"; break;
        case 52:  str_Radius = "1.360"; break;
        case 53:  str_Radius = "1.330"; break;
        case 54:  str_Radius = "1.310"; break;
        case 55:  str_Radius = "2.350"; break;
        case 56:  str_Radius = "1.980"; break;
        case 57:  str_Radius = "1.690"; break;
        case 58:  str_Radius = "1.650"; break;
        case 59:  str_Radius = "1.650"; break;
        case 60:  str_Radius = "1.640"; break;
        case 61:  str_Radius = "1.630"; break;
        case 62:  str_Radius = "1.620"; break;
        case 63:  str_Radius = "1.850"; break;
        case 64:  str_Radius = "1.610"; break;
        case 65:  str_Radius = "1.590"; break;
        case 66:  str_Radius = "1.590"; break;
        case 67:  str_Radius = "1.580"; break;
        case 68:  str_Radius = "1.570"; break;
        case 69:  str_Radius = "1.560"; break;
        case 70:  str_Radius = "1.740"; break;
        case 71:  str_Radius = "1.560"; break;
        case 72:  str_Radius = "1.440"; break;
        case 73:  str_Radius = "1.340"; break;
        case 74:  str_Radius = "1.300"; break;
        case 75:  str_Radius = "1.280"; break;
        case 76:  str_Radius = "1.260"; break;
        case 77:  str_Radius = "1.270"; break;
        case 78:  str_Radius = "1.300"; break;
        case 79:  str_Radius = "1.340"; break;
        case 80:  str_Radius = "1.490"; break;
        case 81:  str_Radius = "1.480"; break;
        case 82:  str_Radius = "1.470"; break;
        case 83:  str_Radius = "1.460"; break;
        case 84:  str_Radius = "1.460"; break;
        case 85:  str_Radius = "1.450"; break;
        case 86:  str_Radius = "1.440"; break;
        case 87:  str_Radius = "2.510"; break;
        case 88:  str_Radius = "2.140"; break;
        case 89:  str_Radius = "1.750"; break;
        case 90:  str_Radius = "1.650"; break;
        case 91:  str_Radius = "1.530"; break;
        case 92:  str_Radius = "1.420"; break;
        case 93:  str_Radius = "1.410"; break;
        case 94:  str_Radius = "1.410"; break;
        case 95:  str_Radius = "1.610"; break;
        case 96:  str_Radius = "1.400"; break;
        case 97:  str_Radius = "1.400"; break;
        case 98:  str_Radius = "1.390"; break;
        case 99:  str_Radius = "1.390"; break;
        case 100:  str_Radius = "1.390"; break;
        case 101:  str_Radius = "1.380"; break;
        case 102:  str_Radius = "1.380"; break;
        case 103:  str_Radius = "1.380"; break;
        case 104:  str_Radius = "1.380"; break;
        case 105:  str_Radius = "1.380"; break;
        case 106:  str_Radius = "1.380"; break;
        case 107:  str_Radius = "1.380"; break;
        case 108:  str_Radius = "1.380"; break;
        case 109:  str_Radius = "1.380"; break;
        default: str_Radius = "1.0"; break;
      }
      initfile.WriteProfile("Radius", str_i, str_Radius);
    }
    Radius[i-1] = str_Radius.toFloat();

    // read colors from INITFILE
    str_Color = initfile.GetProfile("Color", str_i, "");
    if(str_Color == "")
    {
      switch( i )
      {
        case 1:  tmpColor.setRgb(220,220,220); break;
        case 2:  tmpColor.setRgb(160,160,160); break;
        case 3:  tmpColor.setRgb(160,160,160); break;
        case 4:  tmpColor.setRgb(160,160,160); break;
        case 5:  tmpColor.setRgb(160,160,160); break;
        case 6:  tmpColor.setRgb(50,50,50);    break;
        case 7: tmpColor.setRgb(0,200,0);     break;
        case 8: tmpColor.setRgb(0,0,200);     break;
        case 9: tmpColor.setRgb(160,160,0);   break;
        case 10: tmpColor.setRgb(160,160,160); break;
        case 11: tmpColor.setRgb(160,160,160); break;
        case 12: tmpColor.setRgb(160,160,160); break;
        case 13: tmpColor.setRgb(160,160,160); break;
        case 14: tmpColor.setRgb(160,160,160); break;
        case 15: tmpColor.setRgb(200,0,0);     break;
        case 16: tmpColor.setRgb(220,220,0);   break;
        case 17: tmpColor.setRgb(0,170,0);     break;
        case 18: tmpColor.setRgb(160,160,160); break;
        case 19: tmpColor.setRgb(160,160,160); break;
        case 20: tmpColor.setRgb(160,160,160); break;
        case 21: tmpColor.setRgb(160,160,160); break;
        case 22: tmpColor.setRgb(160,160,160); break;
        case 23: tmpColor.setRgb(160,160,160); break;
        case 24: tmpColor.setRgb(160,160,160); break;
        case 25: tmpColor.setRgb(160,160,160); break;
        case 26: tmpColor.setRgb(160,160,160); break;
        case 27: tmpColor.setRgb(160,160,160); break;
        case 28: tmpColor.setRgb(160,160,160); break;
        case 29: tmpColor.setRgb(160,160,160); break;
        case 30: tmpColor.setRgb(160,160,160); break;
        case 31: tmpColor.setRgb(160,160,160); break;
        case 32: tmpColor.setRgb(160,160,160); break;
        case 33: tmpColor.setRgb(160,160,160); break;
        case 34: tmpColor.setRgb(170,0,0);     break;
        case 35: tmpColor.setRgb(100,100,0);   break;
        case 36: tmpColor.setRgb(160,160,160); break;
        case 37: tmpColor.setRgb(160,160,160); break;
        case 38: tmpColor.setRgb(160,160,160); break;
        case 39: tmpColor.setRgb(160,160,160); break;
        case 40: tmpColor.setRgb(160,160,160); break;
        case 41: tmpColor.setRgb(160,160,160); break;
        case 42: tmpColor.setRgb(160,160,160); break;
        case 43: tmpColor.setRgb(160,160,160); break;
        case 44: tmpColor.setRgb(160,160,160); break;
        case 45: tmpColor.setRgb(160,160,160); break;
        case 46: tmpColor.setRgb(160,160,160); break;
        case 47: tmpColor.setRgb(160,160,160); break;
        case 48: tmpColor.setRgb(160,160,160); break;
        case 49: tmpColor.setRgb(160,160,160); break;
        case 50: tmpColor.setRgb(160,160,160); break;
        case 51: tmpColor.setRgb(160,160,160); break;
        case 52: tmpColor.setRgb(160,160,160); break;
        case 53: tmpColor.setRgb(90,90,100);   break;
        case 54: tmpColor.setRgb(160,160,160); break;
        case 55: tmpColor.setRgb(160,160,160); break;
        case 56: tmpColor.setRgb(160,160,160); break;
        case 57: tmpColor.setRgb(160,160,160); break;
        case 58: tmpColor.setRgb(160,160,160); break;
        case 59: tmpColor.setRgb(160,160,160); break;
        case 60: tmpColor.setRgb(160,160,160); break;
        case 61: tmpColor.setRgb(160,160,160); break;
        case 62: tmpColor.setRgb(160,160,160); break;
        case 63: tmpColor.setRgb(160,160,160); break;
        case 64: tmpColor.setRgb(160,160,160); break;
        case 65: tmpColor.setRgb(160,160,160); break;
        case 66: tmpColor.setRgb(160,160,160); break;
        case 67: tmpColor.setRgb(160,160,160); break;
        case 68: tmpColor.setRgb(160,160,160); break;
        case 69: tmpColor.setRgb(160,160,160); break;
        case 70: tmpColor.setRgb(160,160,160); break;
        case 71: tmpColor.setRgb(160,160,160); break;
        case 72: tmpColor.setRgb(160,160,160); break;
        case 73: tmpColor.setRgb(160,160,160); break;
        case 74: tmpColor.setRgb(160,160,160); break;
        case 75: tmpColor.setRgb(160,160,160); break;
        case 76: tmpColor.setRgb(160,160,160); break;
        case 77: tmpColor.setRgb(160,160,160); break;
        case 78: tmpColor.setRgb(160,160,160); break;
        case 79: tmpColor.setRgb(160,160,160); break;
        case 80: tmpColor.setRgb(160,160,160); break;
        case 81: tmpColor.setRgb(160,160,160); break;
        case 82: tmpColor.setRgb(160,160,160); break;
        case 83: tmpColor.setRgb(160,160,160); break;
        case 84: tmpColor.setRgb(160,160,160); break;
        case 85: tmpColor.setRgb(160,160,160); break;
        case 86: tmpColor.setRgb(160,160,160); break;
        case 87: tmpColor.setRgb(160,160,160); break;
        case 88: tmpColor.setRgb(160,160,160); break;
        case 89: tmpColor.setRgb(160,160,160); break;
        case 90: tmpColor.setRgb(160,160,160); break;
        case 91: tmpColor.setRgb(160,160,160); break;
        case 92: tmpColor.setRgb(160,160,160); break;
        case 93: tmpColor.setRgb(160,160,160); break;
        case 94: tmpColor.setRgb(160,160,160); break;
        case 95: tmpColor.setRgb(160,160,160); break;
        case 96: tmpColor.setRgb(160,160,160); break;
        case 97: tmpColor.setRgb(160,160,160); break;
        case 98: tmpColor.setRgb(160,160,160); break;
        case 99: tmpColor.setRgb(160,160,160); break;
        case 100: tmpColor.setRgb(160,160,160); break;
        case 101: tmpColor.setRgb(160,160,160); break;
        case 102: tmpColor.setRgb(160,160,160); break;
        case 103: tmpColor.setRgb(160,160,160); break;
        case 104: tmpColor.setRgb(160,160,160); break;
        case 105: tmpColor.setRgb(160,160,160); break;
        case 106: tmpColor.setRgb(160,160,160); break;
        case 107: tmpColor.setRgb(160,160,160); break;
        case 108: tmpColor.setRgb(160,160,160); break;
        case 109: tmpColor.setRgb(160,160,160); break;
        default: tmpColor.setRgb(160,160,160); break;
      }
      str_Color.setNum(tmpColor.rgb() & 16777215);
      initfile.WriteProfile("Color", str_i, str_Color);
    }
    Color[i-1] = str_Color.toUInt();

    // read patterns from INITFILE
    str_Pattern = initfile.GetProfile("Pattern", str_i, "");
    if(str_Pattern == "") str_Pattern.setNum(Qt::SolidPattern);
    Pattern[i-1] = str_Pattern.toUInt();
    initfile.WriteProfile("Pattern", str_i, str_Pattern);
  }
}

/////////////////////////////////////////////////////////////////////////////
// destructor
CKPeriodicSystem::~CKPeriodicSystem()
{

}

/////////////////////////////////////////////////////////////////////////////
// = operator
CKPeriodicSystem& CKPeriodicSystem::operator=(CKPeriodicSystem &pse)
{
  CPeriodicSystem::operator=(pse);
  return *this;
}

/////////////////////////////////////////////////////////////////////////////
// RestoreDataFromINIFile
int CKPeriodicSystem::RestoreDataFromINIFile(void)
{
  int result = TRUE;
  int i = 0;
  QString str_i = "";
  QString str_Radius = "";
  QString str_Color = "";
  QString str_Pattern = "";

  for(i = 1; i < 110; i++)
  {
    str_i.setNum(i);

    str_Radius = initfile.GetProfile("Radius", str_i, "");
    if(str_Radius == "")
      result = FALSE;
    else
      Radius[i - 1] = str_Radius.toFloat();

    str_Color = initfile.GetProfile("Color", str_i, "");
    if(str_Color == "")
      result = FALSE;
    else
      Color[i - 1] = str_Color.toUInt();

    str_Pattern = initfile.GetProfile("Pattern", str_i, "");
    if(str_Pattern == "")
      result = FALSE;
    else
      Pattern[i - 1] = str_Pattern.toUInt();
  }
  return result;
}

/////////////////////////////////////////////////////////////////////////////
// GetElements
int CKPeriodicSystem::GetElements(kmpi::CIPluginElements& el)
{
  kmpi::CIPluginColor pluginColor;
  bool error = FALSE;
  for(int i = 1; !error && i <= 109 && i <= kmpi::KMPI_MAX_ELEMENT_NUMBER; i++)
  {
    error = (!error ? error = (pluginColor.setColor(GetColor(i).red(), GetColor(i).green(), GetColor(i).blue()) == kmpi::KMPI_ERROR) : TRUE);
    error = (!error ? error = (el.setColor((unsigned int)i, pluginColor) == kmpi::KMPI_ERROR) : TRUE);
    error = (!error ? error = (el.setRadius((unsigned int)i, GetRadius(i)) == kmpi::KMPI_ERROR) : TRUE);
  }
  return(!error);
}

/////////////////////////////////////////////////////////////////////////////
// SetElements
int CKPeriodicSystem::SetElements(kmpi::CIPluginElements& el)
{
  bool error = FALSE;
  QColor color;
  for(int i = 1; !error && i <= 109 && i <= kmpi::KMPI_MAX_ELEMENT_NUMBER; i++)
  {
    color.setRgb(el.getColor((unsigned int)i).getColorRed(), el.getColor((unsigned int)i).getColorGreen(), el.getColor((unsigned int)i).getColorBlue());
    error = (!error ? error = (!SetColor(i, color)) : TRUE);
    error = (!error ? error = (!SetRadius(i, el.getRadius(i))) : TRUE);
  }  
  return(!error);
}

/////////////////////////////////////////////////////////////////////////////
// SaveAll
int CKPeriodicSystem::SaveAll(void)
{
  int result = TRUE;
  int tmpresult = TRUE;

  for(int i = 1; i < 110; i++)
  {
    tmpresult = SaveRadius(i, Radius[i - 1]);
    if(tmpresult == FALSE) result = FALSE;
    tmpresult = SaveColor(i, Color[i - 1]);
    if(tmpresult == FALSE) result = FALSE;
    tmpresult = SavePattern(i, Pattern[i - 1]);
    if(tmpresult == FALSE) result = FALSE;
  }

  return result;
}

/////////////////////////////////////////////////////////////////////////////
// SaveRadius
int CKPeriodicSystem::SaveRadius(int ordinalNumber, float radius)
{
  if((ordinalNumber < 1) || (ordinalNumber > 109) || (Radius < 0)) return FALSE;

  QString str_i = "";
  QString str_Radius = "";

  str_i.setNum(ordinalNumber);
  str_Radius.setNum(radius);

  if(initfile.WriteProfile("Radius", str_i, str_Radius))
  {
    Radius[ordinalNumber-1] = str_Radius.toFloat();
    return TRUE;
  }
  else
    return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// SaveColor
int CKPeriodicSystem::SaveColor(int ordinalNumber, QColor color)
{
  if((ordinalNumber < 1) || (ordinalNumber > 109)) return FALSE;

  QString str_i = "";
  QString str_Color = "";

  str_i.setNum(ordinalNumber);
  str_Color.setNum(color.rgb() & 16777215);

  if(initfile.WriteProfile("Color", str_i, str_Color))
  {
    Color[ordinalNumber-1] = str_Color.toUInt();
    return TRUE;
  }
  else
    return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// SavePattern
int CKPeriodicSystem::SavePattern(int ordinalNumber, int pattern)
{
  if((ordinalNumber < 1) || (ordinalNumber > 109)) return FALSE;

  QString str_i = "";
  QString str_Pattern = "";

  str_i.setNum(ordinalNumber);
  str_Pattern.setNum(pattern);

  if(initfile.WriteProfile("Pattern", str_i, str_Pattern))
  {
    Pattern[ordinalNumber-1] = str_Pattern.toUInt();
    return TRUE;
  }
  else
    return FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// definition of the class CKGLMolecule
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// constructor
CKGLMolecule::CKGLMolecule(QObject *parent, const char *name)
  : CGLMolecule(parent, name)
{
  // look also CMolecule::DeleteMolecule
  // read parameters from INIFILE
  RestoreDataFromINIFile();
}

/////////////////////////////////////////////////////////////////////////////
// destructor
CKGLMolecule::~CKGLMolecule()
{

}

/////////////////////////////////////////////////////////////////////////////
// = operator
CKGLMolecule& CKGLMolecule::operator=(CKGLMolecule &mol)
{
  CGLMolecule::operator=(mol);
  return *this;
}

/////////////////////////////////////////////////////////////////////////////
// GetMolecule
int CKGLMolecule::GetMolecule(kmpi::CIPluginMolecule& mol, const kmpi::CIPluginElements& el)
{
  kmpi::CIPluginElements elements;
  elements = el;
  kmpi::CIPluginColor color;
  int i = 1;
  unsigned int index = 0;  
  bool error = FALSE;
  error = (mol.deleteAll((kmpi::KMPI_BOOL)TRUE, (kmpi::KMPI_BOOL)TRUE) == kmpi::KMPI_ERROR);
  for(i = 0; !error && i < GetNumberOfAtoms() && i < kmpi::KMPI_MAX_ELEMENT_NUMBER; i++)
  {
    error = (!error ? error = (color.setColor((unsigned int)GetColor(i).red(), (unsigned int)GetColor(i).green(), (unsigned int)GetColor(i).blue()) == kmpi::KMPI_ERROR) : TRUE);
    error = (!error ? error = (elements.setColor((unsigned int)(i + 1), color) == kmpi::KMPI_ERROR) : TRUE);
    error = (!error ? error = (elements.setRadius((unsigned int)(i + 1), GetRadius(i)) == kmpi::KMPI_ERROR) : TRUE);
    error = (!error ? error = ((index = mol.addAtom(&elements, (unsigned int)GetOrdinalNumber(i))) == 0) : TRUE);
    error = (!error ? error = (mol.setAtomPosition(index, GetAtomCoordinate(i, 1, 1).x, GetAtomCoordinate(i, 1, 1).y, GetAtomCoordinate(i, 1, 1).z) == kmpi::KMPI_ERROR) : TRUE);    
  }
  for(i = 0; !error && i < GetNumberOfBonds(); i++)
  {    
    error = (!error ? error = (mol.addBond(((unsigned int)GetBond(i).x + 1), ((unsigned int)GetBond(i).y + 1)) == 0) : TRUE);
  }
  error = (!error ? error = (mol.setBondColor((unsigned int)GetBondColor().red(), (unsigned int)GetBondColor().green(), (unsigned int)GetBondColor().blue()) == kmpi::KMPI_ERROR) : TRUE);
  error = (!error ? error = (mol.setBondRadius(GetBondRadius()) == kmpi::KMPI_ERROR) : TRUE);
  error = (!error ? error = (mol.setTitle((const char*)GetTitle()) == kmpi::KMPI_ERROR) : TRUE);  
  return(!error);
}

/////////////////////////////////////////////////////////////////////////////
// SetMolecule
int CKGLMolecule::SetMolecule(kmpi::CIPluginMolecule& mol)
{
  unsigned int i = 1;
  bool error = FALSE;
  ELEMENT element;
  QColor color;
  DeleteMolecule();
  for(i = 1; !error && i <= mol.getNumberOfAtoms() && i <= kmpi::KMPI_MAX_ELEMENT_NUMBER; i++)
  {
    element.x = mol.getAtomPosition(i).getPositionX();
    element.y = mol.getAtomPosition(i).getPositionY();
    element.z = mol.getAtomPosition(i).getPositionZ();
    element.OrdinalNumber = int(mol.getAtomNumber(i));    
    element.Label = (int)i;
    element.Radius = mol.getAtomRadius(i);
    element.Color.setRgb(mol.getAtomColor(i).getColorRed(), mol.getAtomColor(i).getColorGreen(), mol.getAtomColor(i).getColorBlue());
    element.Pattern = pse.GetPattern(element.OrdinalNumber);
    error = (!error ? error = !AddAtom(element, 0) : TRUE);
  }
  for(i = 1; !error && i <= mol.getNumberOfBonds(); i++)
  {
    error = (!error ? error = !AddBond(int(mol.getBond(i)->getBondPartner1() - 1), int(mol.getBond(i)->getBondPartner2() - 1)) : TRUE);
  }
  color.setRgb(mol.getBondColor().getColorRed(), mol.getBondColor().getColorGreen(), mol.getBondColor().getColorBlue());
  error = (!error ? error = !SetBondColor(color) : TRUE);
  error = (!error ? error = !SetBondRadius(mol.getBondRadius()) : TRUE);
  error = (!error ? error = !SetTitle(QString(mol.getTitle().c_str())) : TRUE);
  return(error ? InitMolecule() : !error);  
}

/////////////////////////////////////////////////////////////////////////////
// SaveBondFudge
int CKGLMolecule::SaveBondFudge(void)
{
  QString str_BondFudge;
  str_BondFudge.setNum(BondFudge);
  return(initfile.WriteProfile("Parameter", "BondFudge", str_BondFudge));
}

/////////////////////////////////////////////////////////////////////////////
// SaveBondColor
int CKGLMolecule::SaveBondColor(void)
{
  QString str_Color;
  str_Color.setNum(BondColor.rgb() & 16777215);
  return(initfile.WriteProfile("Parameter", "BondColor", str_Color));
}

/////////////////////////////////////////////////////////////////////////////
// SaveRadiusFactor
int CKGLMolecule::SaveRadiusFactor(void)
{
  QString str_RadiusFactor;
  str_RadiusFactor.setNum(RadiusFactor);
  return(initfile.WriteProfile("Parameter", "RadiusFactor", str_RadiusFactor));
}

/////////////////////////////////////////////////////////////////////////////
// SavePerspectiveFactor
int CKGLMolecule::SavePerspectiveFactor(void)
{
  QString str_PerspectiveFactor;
  str_PerspectiveFactor.setNum(PerspectiveFactor);
  return(initfile.WriteProfile("Parameter", "PerspectiveFactor", str_PerspectiveFactor));
}

/////////////////////////////////////////////////////////////////////////////
// SaveLabelType
int CKGLMolecule::SaveLabelType(void)
{
  QString str_LabelType;
  str_LabelType.setNum(LabelType);
  return(initfile.WriteProfile("Parameter", "LabelType", str_LabelType));
}

/////////////////////////////////////////////////////////////////////////////
// SaveBackgroundColor
int CKGLMolecule::SaveBackgroundColor(void)
{
  QString str_bgColor = "";
  str_bgColor.setNum(bgColor.rgb() & 16777215);
  return(initfile.WriteProfile("Parameter", "BGColor", str_bgColor));
}

/////////////////////////////////////////////////////////////////////////////
// SaveBackgroundColorGL
int CKGLMolecule::SaveBackgroundColorGL(void)
{
  QString str_bgColorGL = "";
  str_bgColorGL.setNum(GetBackgroundColorGL().rgb() & 16777215);
  return(initfile.WriteProfile("Parameter", "BGColorGL", str_bgColorGL));
}

/////////////////////////////////////////////////////////////////////////////
// SaveAtomSlicesGL
int CKGLMolecule::SaveAtomSlicesGL(void)
{
  QString str_atomSlicesGL = "";
  str_atomSlicesGL.setNum((int)atomslices);
  return(initfile.WriteProfile("Parameter", "AtomSlicesGL", str_atomSlicesGL));
}

/////////////////////////////////////////////////////////////////////////////
// SaveAtomStacksGL
int CKGLMolecule::SaveAtomStacksGL(void)
{
  QString str_atomStacksGL = "";
  str_atomStacksGL.setNum((int)atomstacks);
  return(initfile.WriteProfile("Parameter", "AtomStacksGL", str_atomStacksGL));
}

/////////////////////////////////////////////////////////////////////////////
// SaveBondSlicesGL
int CKGLMolecule::SaveBondSlicesGL(void)
{
  QString str_bondSlicesGL = "";
  str_bondSlicesGL.setNum((int)bondslices);
  return(initfile.WriteProfile("Parameter", "BondSlicesGL", str_bondSlicesGL));
}

/////////////////////////////////////////////////////////////////////////////
// SaveBondRadiusGL
int CKGLMolecule::SaveBondRadiusGL(void)
{
  QString str_bondRadiusGL = "";
  str_bondRadiusGL.setNum(bondradius);
  return(initfile.WriteProfile("Parameter", "BondRadiusGL", str_bondRadiusGL));
}

/////////////////////////////////////////////////////////////////////////////
// RestoreDataFromINIFile
int CKGLMolecule::RestoreDataFromINIFile()
{
  // base class initialisations
  CGLMolecule::InitMolecule();
  // string pendants (required for none string values)
  // of general parameters
  QString str_BondFudge = "";
  QString str_BondColor = "";
  QString str_RadiusFactor = "";
  QString str_PerspectiveFactor = "";
  QString str_LabelType = "";
  QString str_ZoomFactor = "";
  QString str_bgColor = "";
  QString str_bgColorGL = "";
  QString str_atomSlicesGL = "";
  QString str_atomStacksGL = "";
  QString str_bondSlicesGL = "";
  QString str_bondRadiusGL = "";
  
  // general parameters
  if((str_BondFudge = initfile.GetProfile("Parameter", "BondFudge", "")) == "")
  {
    str_BondFudge = "1.12";
    if(!initfile.WriteProfile("Parameter", "BondFudge", str_BondFudge)) return(FALSE);
  }
  BondFudge = str_BondFudge.toFloat();
  if((str_BondColor = initfile.GetProfile("Parameter", "BondColor", "")) == "")
  {
    str_BondColor = "2105376";
    if(!initfile.WriteProfile("Parameter", "BondColor", str_BondColor)) return(FALSE);
  }
  BondColor = (QColor)str_BondColor.toInt();
  if((str_RadiusFactor = initfile.GetProfile("Parameter", "RadiusFactor", "")) == "")
  {
    str_RadiusFactor = "0.5";
    if(!initfile.WriteProfile("Parameter", "RadiusFactor", str_RadiusFactor)) return(FALSE);
  }
  RadiusFactor = str_RadiusFactor.toFloat();
  if((str_PerspectiveFactor = initfile.GetProfile("Parameter", "PerspectiveFactor", "")) == "")
  {
    str_PerspectiveFactor = "2.5";
    if(!initfile.WriteProfile("Parameter", "PerspectiveFactor", str_PerspectiveFactor)) return(FALSE);
  }
  PerspectiveFactor = str_PerspectiveFactor.toFloat();
  if((str_LabelType = initfile.GetProfile("Parameter", "LabelType", "")) == "")
  {
    str_LabelType = "0";
    if(!initfile.WriteProfile("Parameter", "LabelType", str_LabelType)) return(FALSE);
  }
  LabelType = str_LabelType.toInt();  
  if((str_bgColor = initfile.GetProfile("Parameter", "BGColor", "")) == "")
  {
    str_bgColor = "16777215";
    if(!initfile.WriteProfile("Parameter", "BGColor", str_bgColor)) return(FALSE);
  }
  bgColor = (QColor)str_bgColor.toInt();  
  if((str_bgColorGL = initfile.GetProfile("Parameter", "BGColorGL", "")) == "")
  {
    str_bgColorGL = "0";
    if(!initfile.WriteProfile("Parameter", "BGColorGL", str_bgColorGL)) return(FALSE);
  }
  SetBackgroundColorGL((QColor)str_bgColorGL.toInt());
  if((str_atomSlicesGL = initfile.GetProfile("Parameter", "AtomSlicesGL", "")) == "")
  {
    str_atomSlicesGL = "18";
    if(!initfile.WriteProfile("Parameter", "AtomSlicesGL", str_atomSlicesGL)) return(FALSE);
  }
  atomslices = (GLint)str_atomSlicesGL.toInt();
  if((str_atomStacksGL = initfile.GetProfile("Parameter", "AtomStacksGL", "")) == "")
  {
    str_atomStacksGL = "9";
    if(!initfile.WriteProfile("Parameter", "AtomStacksGL", str_atomStacksGL)) return(FALSE);
  }
  atomstacks = (GLint)str_atomStacksGL.toInt();  
  if((str_bondSlicesGL = initfile.GetProfile("Parameter", "BondSlicesGL", "")) == "")
  {
    str_bondSlicesGL = "9";
    if(!initfile.WriteProfile("Parameter", "BondSlicesGL", str_bondSlicesGL)) return(FALSE);
  }
  bondslices = (GLint)str_bondSlicesGL.toInt();
  if((str_bondRadiusGL = initfile.GetProfile("Parameter", "BondRadiusGL", "")) == "")
  {
    str_bondRadiusGL = "0.1";
    if(!initfile.WriteProfile("Parameter", "BondRadiusGL", str_bondRadiusGL)) return(FALSE);
  }
  bondradius = (GLfloat)str_bondRadiusGL.toFloat();
  
  // initialisations
  Title = "";
  ZoomFactor = (float)1.0;

  // initialisation sucsessfull
  return(TRUE);
}


