/***************************************************************************
                          kglmolecule.h  -  description
                             -------------------
    begin                : Sat Sep 7 2002
    copyright            : (C) 2000 - 2003 by M. Hoverath
    email                : mario.hoverath@uni-koeln.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _CKGLMOLECULE
#define _CKGLMOLECULE

#include "molecule.h"
#include "glmolecule.h"

/* application specific includes */
#include "initfile.h"
#include "iplugin.h"

/* class CPeriodicSystem */
class CKPeriodicSystem : public CPeriodicSystem
{
  Q_OBJECT

public:
  /* constructor */
  CKPeriodicSystem(QObject *parent=0, const char *name=0);

  /* destructor */
  ~CKPeriodicSystem();

  /* operators */
  CKPeriodicSystem& operator=(CKPeriodicSystem &pse);

  /* methods */
  int RestoreDataFromINIFile(void);

  /* Get ... */
  int GetElements(kmpi::CIPluginElements& el);

  /* Set ... */
  int SetElements(kmpi::CIPluginElements& el);

  /* save ... */
  int SaveAll(void);
  int SaveRadius(int ordinalNumber, float radius);
  int SaveColor(int ordinalNumber, QColor color);
  int SavePattern(int ordinalNumber, int pattern);

protected:
  CInitFile initfile;
};

/* class CKGLMolecule */
class CKGLMolecule : public CGLMolecule
{
  Q_OBJECT

public:
  /* constructor */
  CKGLMolecule(QObject *parent=0, const char *name=0);

  /* destructor */
  ~CKGLMolecule();

  /* operators */
  CKGLMolecule& operator=(CKGLMolecule &mol);

  /* initialisation */
  int RestoreDataFromINIFile(void);

  /* Get ... */
  int GetMolecule(kmpi::CIPluginMolecule& mol, const kmpi::CIPluginElements& el);
  
  /* Set ... */
  int SetMolecule(kmpi::CIPluginMolecule& mol);

  /* save ... */
  int SaveBondFudge(void);
  int SaveBondColor(void);
  int SaveRadiusFactor(void);
  int SavePerspectiveFactor(void);
  int SaveLabelType(void);
  int SaveBackgroundColor(void);
  int SaveBackgroundColorGL(void);
  int SaveAtomSlicesGL(void);
  int SaveAtomStacksGL(void);
  int SaveBondSlicesGL(void);
  int SaveBondRadiusGL(void);
  
protected:
  CInitFile initfile;
};

#endif /* _CKGLMOLECULE */
