/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Sam Jan 22 16:27:34 CET 2000
    copyright            : (C) 2000 - 2003 by M. Hoverath
    email                : mario.hoverath@uni-koeln.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/* include files for QT */
#include <qapplication.h>
#include <qfont.h>
#include <qwindowsstyle.h>
#include <qcdestyle.h>
#include <qmotifstyle.h>
#include <qplatinumstyle.h>
#include <qsgistyle.h>
#include <qwidget.h>
#include <qstring.h>
#include <qdir.h>

/* other include files */
#include "kmovisto.h"
#include "introscreen.h"
#include "initfile.h"
#include "kmovistointro.xpm"

/* constants */
#define WIDTH 640
#define HEIGHT 480
#define MINIMUMWIDTH 320
#define MINIMUMHEIGHT 240
#define INTROSCREENTIME 2500
#define INITFILENAME ".kmovisto"

int main(int argc, char *argv[])
{
  int result = 0;
  QApplication a(argc, argv);
  CInitFile initFile;

  // select the font
  // a.setFont(QFont("helvetica", 12));

  // select your preferred look
  // a.setStyle(new QWindowsStyle);
  // a.setStyle(new QCDEStyle);
  // a.setStyle(new QMotifStyle);
  // a.setStyle(new QPlatinumStyle);
  // a.setStyle(new QSGIStyle);

  // get init file
  QString initFileName = QDir::homeDirPath();
  if(initFileName.right(1) != "/") initFileName += "/";
  initFileName += INITFILENAME;

  // open init file
  if(initFile.OpenInitFile(initFileName))
  {
    // create intro screen
    CIntroScreen *introScreen = new CIntroScreen(kmovistointro);
    introScreen->show(INTROSCREENTIME);

    // create main widget
    KMovisto *kmovisto = new KMovisto();

    // start main window
    kmovisto->setMinimumSize(MINIMUMWIDTH, MINIMUMHEIGHT);
    int posX = (a.desktop()->width() - WIDTH) / 2;
    int posY = (a.desktop()->height() - 40 - HEIGHT) / 2;
    kmovisto->setGeometry((posX > 0 ? posX : 0), (posY > 0 ? posY : 0), WIDTH, HEIGHT);
    a.setMainWidget(kmovisto);
    kmovisto->show();

    // execute kmovisto
    result = a.exec();
    delete introScreen;
    delete kmovisto;
    if(!initFile.CloseInitFile()) initFile.throwErrorMsg();
  }
  else
  {
    // reading the initialisation file fails
    initFile.throwErrorMsg();
  }
  return result;
}
