/***************************************************************************
                          xyzfile.h  -  description
                             -------------------
    begin                : Thu Feb 3 2000
    copyright            : (C) 2000 - 2003 by M. Hoverath
    email                : mario.hoverath@uni-koeln.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 
#ifndef _XYZFILE
#define _XYZFILE

#define XYZ_FILE_MAX_LINE_LENGTH 256

/* include files for QT */
#include <qobject.h>
#include <qstring.h>
#include <qlist.h>
#include <qfile.h>

/* application specific includes */
#include <iostream>

/* class CXYZCoordinate */
class CXYZCoordinate : public QObject
{
  Q_OBJECT
  friend class CXYZFile;
 
public: 
  /* Constructor */
  CXYZCoordinate(QObject *parent=0, const char *name=0);
 
  /* Destructor */
  ~CXYZCoordinate();
 
  /* Operators */
  CXYZCoordinate& operator=(CXYZCoordinate &GXYZAtomcoordinate);
 
  /* Methods */
  void Serialize();
 
  /* Get... */
  QString GetAtomsymbol(void) {return Atomsymbol;}
  float GetX(void) {return (x);} 
  float GetY(void) {return (y);} 
  float GetZ(void) {return (z);} 
 
  /* Set... */
  void SetAtomsymbol(QString symbol) {Atomsymbol = symbol; return;}
  void SetX(float newx) {x = newx; return;} 
  void SetY(float newy) {y = newy; return;} 
  void SetZ(float newz) {z = newz; return;} 

protected: 
  /* Members */
  QString Atomsymbol;
  float x; 
  float y; 
  float z;
}; 


/* Class CXYZFile */
class CXYZFile : public QObject
{
  Q_OBJECT

public: 
  /* Constructor */
  CXYZFile(QObject *parent=0, const char *name=0);
 
  /* Destructor */
  ~CXYZFile();

  /* Operators */
  CXYZFile& operator=(CXYZFile &XYZFile);

  /* Methods */
  void Serialize(void);
  void Reset(void);
  int LoadFile(QString Path);
  int SaveFile(QString Path);

  /* Get ... */
  int GetNumberOfAtoms(void);
  QString GetTitle(void);
  int GetCoordinate(int LineNumber, CXYZCoordinate& Coordinate);  

  /* Set ... */
  int SetTitle(QString title);
  int SetCoordinate(CXYZCoordinate& Coordinate);  

protected:
  /* Members */
  QList <CXYZCoordinate> XYZAtomcoordinateList;
  int NumberOfAtoms;
  QString Title;
  CXYZCoordinate *coordinate;
};

#endif /* _XYZFILE */
